﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Windows.Input;
using Microsoft.Practices.Composite.Presentation.Commands;

namespace WpfApplication4
{
    public class RegisterUserViewModel : INotifyPropertyChanged
    {
        public RegisterUserViewModel()
        {
            this.UserName = "Baobao";
            this.Age = 27;

            ClickCommand = new DelegateCommand<object>(OnClick, arg => true);
        }

        void OnClick(object obj)
        {
            this.Age += 1;
        }

        public RegisterUserView View { get; set; }

        public ICommand ClickCommand { get; set; }

        public string UserName { get; set; }

        private int age;
        public int Age
        {
            get 
            { 
                return this.age; 
            }
            set
            {
                if (this.age != value)
                {
                    this.age = value;
                    OnPropertyChanged("Age");
                }
            }
        }
        
        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        #endregion
    }
}